de.caff.gimmicks.swing

## Enum CollapsibleTabbedPane.Side

- java.lang.Object
- - java.lang.Enum<CollapsibleTabbedPane.Side>
  - - de.caff.gimmicks.swing.CollapsibleTabbedPane.Side

- All Implemented Interfaces:
    java.io.Serializable, java.lang.Comparable<CollapsibleTabbedPane.Side>
  Enclosing class:
    CollapsibleTabbedPane

      public static enum CollapsibleTabbedPane.Side
      extends java.lang.Enum<CollapsibleTabbedPane.Side>

  The side where the expandable pane is placed.

- - ### Enum Constant Summary

    Enum Constants
    Enum Constant and Description
    `East` At the eastern side.
    `North` At the northern side.
    `South` At the southern side.
    `West` At the western side.

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `(package private) java.lang.String` | `i18nHideActionTag`
    `(package private) java.lang.String` | `naturalBorder`
    `(package private) int` | `tabPlacement`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `getCoordinateOfInterest(int x, int y)` Get the coordinate which is expandable.
    `java.awt.Dimension` | `getDimension(java.awt.Dimension basicDimension, int expandedSize)` Get the expandable dimension.
    `CollapsibleTabbedPane.ExpandableDirection` | `getExpandableDirection()` Get the direction in which a collapsible tabbed pane for this side is expanded.
    `java.lang.String` | `getI18nHideActionTag()` Get the i18n action tag for the hide action.
    `java.lang.String` | `getNaturalBorder()` Get the natural border for `BorderLayout` where a collapsible tabbed pane for this size should be placed.
    `java.awt.Cursor` | `getResizeCursor()` Get the resize cursor associated with this size.
    `java.awt.Dimension` | `getSize(javax.swing.JComponent comp, java.awt.Point pos, int dividerSize)` Get the new size during resizing.
    `int` | `getTabPlacement()` Get the tab placement constant which is associated with this side.
    `boolean` | `isOverDivider(javax.swing.JComponent comp, java.awt.Point pos, int dividerSize)` Is the cursor over the divider set by `setDivider(JComponent, int, Color)`?
    `void` | `setDivider(javax.swing.JComponent comp, int dividerSize, java.awt.Color color)` Create a divider by setting a border to the component.
    `static CollapsibleTabbedPane.Side` | `valueOf(java.lang.String name)` Returns the enum constant of this type with the specified name.
    `static CollapsibleTabbedPane.Side[]` | `values()` Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods inherited from class java.lang.Enum

      `clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Enum Constant Detail

    - #### North

          public static final CollapsibleTabbedPane.Side North

      At the northern side.

    - #### East

          public static final CollapsibleTabbedPane.Side East

      At the eastern side.

    - #### South

          public static final CollapsibleTabbedPane.Side South

      At the southern side.

    - #### West

          public static final CollapsibleTabbedPane.Side West

      At the western side.

  - ### Field Detail

    - #### tabPlacement

          final int tabPlacement

    - #### naturalBorder

          @NotNull
          final java.lang.String naturalBorder

    - #### i18nHideActionTag

          @NotNull
          final java.lang.String i18nHideActionTag

  - ### Method Detail

    - #### values

          public static CollapsibleTabbedPane.Side[] values()

      Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

          for (CollapsibleTabbedPane.Side c : CollapsibleTabbedPane.Side.values())
              System.out.println(c);

      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static CollapsibleTabbedPane.Side valueOf(java.lang.String name)

      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `java.lang.IllegalArgumentException` - if this enum type has no constant with the specified name
        `java.lang.NullPointerException` - if the argument is null

    - #### getTabPlacement

          public int getTabPlacement()

      Get the tab placement constant which is associated with this side.
      Returns:
        tab placement constant

    - #### getNaturalBorder

          @NotNull
          public java.lang.String getNaturalBorder()

      Get the natural border for `BorderLayout` where a collapsible tabbed pane for this size should be placed.
      Returns:
        border layout border constant

    - #### getI18nHideActionTag

          @NotNull
          public java.lang.String getI18nHideActionTag()

      Get the i18n action tag for the hide action.
      Returns:
        i18n tag

    - #### getExpandableDirection

          @NotNull
          public CollapsibleTabbedPane.ExpandableDirection getExpandableDirection()

      Get the direction in which a collapsible tabbed pane for this side is expanded.
      Returns:
        expandable direction

    - #### getResizeCursor

          @NotNull
          public java.awt.Cursor getResizeCursor()

      Get the resize cursor associated with this size.
      Returns:
        resize cursor

    - #### getDimension

          @NotNull
          public java.awt.Dimension getDimension(@NotNull
                                                          java.awt.Dimension basicDimension,
                                                          int expandedSize)

      Get the expandable dimension.
      Parameters:
        `basicDimension` - basic dimension of the component
        `expandedSize` - size of the expandable direction
      Returns:
        the combined dimension

    - #### getCoordinateOfInterest

          public int getCoordinateOfInterest(int x,
                                             int y)

      Get the coordinate which is expandable.
      Parameters:
        `x` - x coordinate
        `y` - y coordinate
      Returns:
        either x or y

    - #### setDivider

          public void setDivider(@NotNull
                                 javax.swing.JComponent comp,
                                 int dividerSize,
                                 @Nullable
                                 java.awt.Color color)

      Create a divider by setting a border to the component.
      Parameters:
        `comp` - component to instrument with a divider
        `dividerSize` - size of divider
        `color` - color of divider, `null` for empty

    - #### isOverDivider

          public boolean isOverDivider(@NotNull
                                       javax.swing.JComponent comp,
                                       @NotNull
                                       java.awt.Point pos,
                                       int dividerSize)

      Is the cursor over the divider set by `setDivider(JComponent, int, Color)`?
      Parameters:
        `comp` - component with divider
        `pos` - mouse position
        `dividerSize` - size of divider
      Returns:
        `true` if the mouse is over the divider,
        `false` if not

    - #### getSize

          @NotNull
          public java.awt.Dimension getSize(@NotNull
                                                     javax.swing.JComponent comp,
                                                     @NotNull
                                                     java.awt.Point pos,
                                                     int dividerSize)

      Get the new size during resizing.
      Parameters:
        `comp` - component with divider
        `pos` - mouse position
        `dividerSize` - dimension indicated by mouse position
      Returns:
        resizred dimension